presentation/src/main/java/omnidoc/presentation/model/diagram/BasicDiagramView.java
package omnidoc.presentation.model.diagram;

import org.primefaces.model.diagram.Connection;
import org.primefaces.model.diagram.DefaultDiagramModel;
import org.primefaces.model.diagram.Element;
import org.primefaces.model.diagram.endpoint.DotEndPoint;
import org.primefaces.model.diagram.endpoint.EndPointAnchor;

import javax.faces.view.ViewScoped;
import javax.inject.Named;
import java.io.Serializable;

@Named
@ViewScoped
public class BasicDiagramView implements Serializable {

    private static final long serialVersionUID = 3220192058282564175L;
    private DefaultDiagramModel model;

    public BasicDiagramView() {
        model = new DefaultDiagramModel();
        model.setMaxConnections(-1);

        Element elementA = new Element("A", "20em", "6em");
        elementA.addEndPoint(new DotEndPoint(EndPointAnchor.BOTTOM));

        Element elementB = new Element("B", "10em", "18em");
        elementB.addEndPoint(new DotEndPoint(EndPointAnchor.TOP));

        Element elementC = new Element("C", "40em", "18em");
        elementC.addEndPoint(new DotEndPoint(EndPointAnchor.TOP));

        model.addElement(elementA);
        model.addElement(elementB);
        model.addElement(elementC);

        model.connect(new Connection(elementA.getEndPoints().get(0), elementB.getEndPoints().get(0)));
        model.connect(new Connection(elementA.getEndPoints().get(0), elementC.getEndPoints().get(0)));
    }

    public DefaultDiagramModel getModel() {
        return model;
    }
}

presentation/src/main/java/omnidoc/presentation/model/diagram/IDiagramLayout.java
package omnidoc.presentation.model.diagram;

/**
 * This specifies the layout of the components and the elements of the diagram
 */
public interface IDiagramLayout {

    void applyLayout();

}

presentation/src/main/java/omnidoc/presentation/model/panel/DashboardPanel.java
package omnidoc.presentation.model.panel;

import java.util.List;

public class DashboardPanel {
    private String id, header;
    private List<PanelAction> actions;
    private PanelType type;

    public DashboardPanel(String id, String header, PanelType type) {
        this.id = id;
        this.header = header;
        this.type = type;
    }

    public DashboardPanel(String id, String header, PanelType type, List<PanelAction> actions) {
        this.id = id;
        this.header = header;
        this.actions = actions;
        this.type = type;
    }

    public String getId() {
        return id;
    }

    public String getHeader() {
        return header;
    }

    public String getIncludePath() {
        return type.getPath();
    }

    public List<PanelAction> getActions() {
        return actions;
    }

    public PanelType getType() {
        return type;
    }

    public void setType(PanelType type) {
        this.type = type;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj instanceof DashboardPanel) {
            return this.id.equals(((DashboardPanel) obj).getId());
        }
        return false;
    }

    @Override
    public int hashCode() {
        return id.hashCode();
    }
}

presentation/src/main/java/omnidoc/presentation/controller/DashboardController.java
package omnidoc.presentation.controller;

import omnidoc.business.domain.site.NetworkSite;
import omnidoc.business.domain.topology.NetworkTopology;
import omnidoc.business.services.settings.ISettingsService;
import omnidoc.business.services.site.SiteService;
import omnidoc.presentation.manager.NavigationManager;
import omnidoc.presentation.manager.SiteManager;
import omnidoc.presentation.model.panel.DashboardPanel;
import omnidoc.presentation.model.panel.PanelProducer;
import omnidoc.presentation.model.panel.PanelType;
import omnidoc.presentation.model.preference.DashboardPreference;
import omnidoc.presentation.util.Page;
import omnidoc.presentation.util.Resources;
import org.primefaces.component.panel.Panel;
import org.primefaces.event.CloseEvent;
import org.primefaces.event.DashboardReorderEvent;
import org.primefaces.model.DashboardColumn;
import org.primefaces.model.DashboardModel;
import org.primefaces.model.DefaultDashboardColumn;
import org.primefaces.model.DefaultDashboardModel;

import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;
import java.util.*;

/**
 * TODO: Diagrams should be editable (add router/switch/client and connections)
 * - auto load rest of info from db if new device is created with existing info
 * - maybe panel should have small menu to add devices
 * - or only detail page can be used to edit info
 * - diagram could be updateable with new scan results (git like diff)
 * - mindmaps should be used for grouping items like ips in a subnet
 * - organigram could be used
 * - for locations/projects and their subgroups
 * - for user rights control
 */

@Named
@ViewScoped
public class DashboardController implements Serializable {

    private static final long serialVersionUID = 248565168871629523L;

    private NetworkSite selectedSite;
    private DashboardModel dashboard;
    private List<DashboardPanel> panels;
    private ResourceBundle bundle;

    @Inject
    private SiteService siteService;

    @Inject
    private ISettingsService settingsService;

    @PostConstruct
    public void init() {
        selectedSite = SiteManager.getCurrentSite();
        if (selectedSite == null) return;
        selectedSite = siteService.findById(SiteManager.getCurrentSite().getId());

        bundle = Resources.getMessageBundle(Resources.dashboardBundle);

        if (selectedSite != null) {
            SiteManager.setCurrentSite(selectedSite);
            if (selectedSite.getTopology() == null ||
                    selectedSite.getTopology().getComponents().isEmpty()) {
                sendDashboardIsEmptyMessage();
            }
        }

        panels = setupPanels(selectedSite);
        populateDashboard();
    }

    private void sendDashboardIsEmptyMessage() {
        FacesMessage message = new FacesMessage(
                bundle.getString("dashboardIsEmpty"),
                bundle.getString("dashboardIsEmptyTip")
        );
        FacesContext.getCurrentInstance().addMessage(null, message);
    }

    public DashboardModel getDashboard() {
        return dashboard;
    }

    public List<DashboardPanel> getPanels() {
        return panels;
    }

    public NetworkSite getSelectedSite() {
        return SiteManager.getCurrentSite();
    }

    /**
     * Gets called on {@link Page#DASHBOARD} load.
     * If no {@link NetworkSite} is selected by the User, the page will be redirected to {@link Page#STARTPAGE}
     *
     * @return Redirection Path to {@link Page#STARTPAGE} or null
     */
    public String checkForRedirection() {
        return SiteManager.getCurrentSite() != null ? null : NavigationManager.to(Page.STARTPAGE);
    }

    private List<DashboardPanel> setupPanels(NetworkSite selectedSite) {
        if (selectedSite == null) return new ArrayList<>();
        List<String> panelNames = settingsService.findAllPanelsBySite(selectedSite);
        if (panelNames.isEmpty()) panelNames = createDefaultDashboardLayout(selectedSite.getTopology());
        DashboardPreference preference = DashboardPreference.fromPanelNames(panelNames);
        return preference.getPanels();
    }

    private List<String> createDefaultDashboardLayout(NetworkTopology topology) {
        List<String> panelNames = new ArrayList<>();
        if (topology == null) return panelNames;
        panelNames.add(PanelType.MINDMAP.getName());
        panelNames.add(PanelType.COMPONENTS.getName());
        panelNames.add(PanelType.DONUT_CHART.getName());
        return panelNames;
    }

    /**
     * Populates Dashboard from {@link #panels} List
     */
    private void populateDashboard() {
        dashboard = new DefaultDashboardModel();

        DashboardColumn column1 = new DefaultDashboardColumn();
        DashboardColumn column2 = new DefaultDashboardColumn();
        DashboardColumn column3 = new DefaultDashboardColumn();

        if (panels != null && !panels.isEmpty()) {
            for (DashboardPanel panel : panels) {
                column1.addWidget(panel.getId());
            }
        }

        dashboard.addColumn(column1);
        dashboard.addColumn(column2);
        dashboard.addColumn(column3);
    }

    /**
     * Gets all availbale Panel Types for Topology.
     *
     * @return Array of PanelTypes
     */
    public PanelType[] getPanelTypes() {
        PanelType[] panels = PanelType.values();
        NetworkTopology topology = selectedSite.getTopology();
        if (topology == null || topology.getComponents().isEmpty()) {
            for (PanelType panel : panels) {
                if (panel == PanelType.DONUT_CHART ||
                        panel == PanelType.MINDMAP ||
                        panel == PanelType.COMPONENTS ||
                        panel == PanelType.EDITABLE_DIAGRAM) {
                    panel.setEnabled(false);
                }
            }
        }
        return panels;
    }

    /**
     * Prepares Types of Panels for facelet
     *
     * @return List of {@link DashboardPanel}
     */
    public List<DashboardPanel> getDashboardPanelTypes() {
        String messageKey = "panel.";
        String header;
        List<DashboardPanel> panels = new ArrayList<>();
        for (PanelType panelType : PanelType.values()) {
            if (bundle.containsKey(messageKey + panelType.getName())) {
                header = bundle.getString(messageKey + panelType.getName());
            } else {
                header = bundle.getString(messageKey + "default");
            }
            panels.add(new DashboardPanel(panelType.getName(), header, panelType));
        }
        return panels;
    }

    /**
     * Adds Panel from facelet
     *
     * @param panelType Type of {@link DashboardPanel}
     */
    public void addPanel(String panelType) {
        if (panelType == null || panelType.isEmpty()) return;

        DashboardPanel dashboardPanel = PanelProducer.fromName(panelType);
        if (dashboardPanel == null || panels.contains(dashboardPanel)) return;

        panels.add(dashboardPanel);
        settingsService.addPreference(SiteManager.getCurrentSite(), dashboardPanel.getType().getName());
        populateDashboard();
    }

    /**
     * Removes Panel from facelet
     *
     * @param dashboardPanel Panel to remove
     */
    private void removePanel(DashboardPanel dashboardPanel) {
        panels.remove(dashboardPanel);
        settingsService.removePreference(SiteManager.getCurrentSite(), dashboardPanel.getType().getName());
        populateDashboard();
    }

    /**
     * AJAX reorder event
     *
     * @param event from dashboard
     */
    public void handleReorder(DashboardReorderEvent event) {

        if (event.getWidgetId() == null || event.getWidgetId().isEmpty()) return;

        DashboardPanel panel = PanelProducer.fromName(event.getWidgetId());
        if (panel != null) {
            panels.add(event.getItemIndex(), panel);
        } else {
            // Positioning widget in dashboard
            Iterator<DashboardPanel> it = panels.iterator();
            while (it.hasNext()) {
                panel = it.next();
                if (panel.getId().equals(event.getWidgetId())) {
                    it.remove();
                    panels.add(event.getItemIndex(), panel);
                    break;
                }
            }
        }

        FacesMessage message = new FacesMessage();
        message.setSeverity(FacesMessage.SEVERITY_INFO);
        message.setSummary("Reordered: " + event.getWidgetId());
        message.setDetail("Item index: " + event.getItemIndex() + ", Column index: " + event.getColumnIndex() + ", Sender index: " + event.getSenderColumnIndex());
    }

    /**
     * AJAX close event from dashboard
     *
     * @param event from panel
     */
    public void handlePanelClose(CloseEvent event) {
        Panel panelToClose = (Panel) event.getSource();
        Iterator<DashboardPanel> it = panels.iterator();
        while (it.hasNext()) {
            DashboardPanel panel = it.next();
            if (panel.getId().equals(panelToClose.getId())) {
                it.remove();
                return;
            }
        }
    }

    /**
     * AJAX Remote Command called in onDrop Event fom droppable
     */
    public void onPanelDrop() {
        Map<String, String> params = FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap();
        addPanel(params.get("panelType"));
    }
}

presentation/src/main/java/omnidoc/presentation/controller/DetailController.java
package omnidoc.presentation.controller;

import omnidoc.presentation.manager.NavigationManager;
import omnidoc.presentation.model.panel.PanelType;
import omnidoc.presentation.util.Page;

import javax.faces.view.ViewScoped;
import javax.inject.Named;
import java.io.Serializable;

@Named
@ViewScoped
public class DetailController implements Serializable {

    private static final long serialVersionUID = -8180717019323789254L;
    private String panelType;

    public String getPanelType() {
        return panelType;
    }

    public void setPanelType(String panelType) {
        this.panelType = panelType;
    }

    public String getPagePath() {
        PanelType panel = PanelType.fromName(panelType);
        return panel != null ? panel.getPath() : "";
    }

    public String checkPage() {
        if (panelType == null || PanelType.fromName(this.panelType) == null) return NavigationManager.to(Page.STARTPAGE);
        return null;
    }
}

presentation/src/main/java/omnidoc/presentation/controller/SettingsController.java
package omnidoc.presentation.controller;

import omnidoc.presentation.data.SiteProducer;
import omnidoc.presentation.manager.NavigationManager;
import omnidoc.presentation.util.Page;

import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;

// TODO: Add User editing page
/* TODO: Add more Roles to application
 * Role Administrator: should be able to edit everything including users
 * Role User: should be allowed to edit his own Sites
 */

@Named
@ViewScoped
public class SettingsController implements Serializable {

    private static final long serialVersionUID = 4375338974139778106L;

    @Inject
    private SiteProducer siteProducer;

    public String addExampleSite() {
        siteProducer.createExampleSite();
        return NavigationManager.to(Page.STARTPAGE);
    }

    public String addSiteWithManualScans() {
        siteProducer.createManualTestScans();
        return NavigationManager.to(Page.STARTPAGE);
    }

    public String addSiteForPresentation() {
        siteProducer.createSiteForPresentation();
        return NavigationManager.to(Page.STARTPAGE);
    }

    public String addSiteForPresentationFinal() {
        siteProducer.createSiteForPresentationFinal();
        return NavigationManager.to(Page.STARTPAGE);
    }
}

presentation/src/main/java/omnidoc/presentation/controller/StartpageController.java
package omnidoc.presentation.controller;

import omnidoc.business.domain.site.NetworkSite;
import omnidoc.business.services.site.SiteService;
import omnidoc.presentation.manager.NavigationManager;
import omnidoc.presentation.manager.SiteManager;
import omnidoc.presentation.util.Page;
import org.primefaces.PrimeFaces;

import javax.faces.event.ActionEvent;
import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;
import java.security.Principal;
import java.util.List;

@Named
@ViewScoped
public class StartpageController implements Serializable {

    private static final long serialVersionUID = -7287315117179870993L;
    private static final String AJAX_PARAM_SUCCESS = "success";

    private NetworkSite selectedNetworkSite;
    private String siteName;

    @Inject
    private SiteService siteService;

    @Inject
    private Principal principal;

    public List<NetworkSite> getSites() {
        return siteService.findAll();
    }

    public String getSiteName() {
        return siteName;
    }

    public void setSiteName(String siteName) {
        this.siteName = siteName;
    }

    public String getUserName() {
        return principal.getName();
    }

    public void onSiteEntryRemoveClick(NetworkSite clickedSite) {
        selectedNetworkSite = clickedSite;
    }

    public String onSiteEntrySelect(NetworkSite clickedSite) {
        SiteManager.setCurrentSite(clickedSite);
        return NavigationManager.to(Page.DASHBOARD);
    }

    public boolean isSelected(NetworkSite networkSite) {
        if (SiteManager.getCurrentSite() == null) return false;
        return SiteManager.getCurrentSite().equals(networkSite);
    }

    /**
     * AJAX onclick event from btn-add-project
     */
    public void addSite(ActionEvent event) {
        boolean success = false;
        if (siteName != null && !siteName.isEmpty()) {
            success = true;
            siteService.add(new NetworkSite(siteName));
            siteName = "";
        }
        PrimeFaces.current().ajax().addCallbackParam(AJAX_PARAM_SUCCESS, success);
    }

    /**
     * AJAX onclick event from btn-remove-project
     */
    public void removeSelectedNetworkSite() {
        siteService.remove(selectedNetworkSite);
        if (SiteManager.isSelected(selectedNetworkSite)) SiteManager.setCurrentSite(null);
        selectedNetworkSite = null;
    }
}

presentation/src/main/webapp/dashboard.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:p="http://primefaces.org/ui"
      xmlns:c="http://java.sun.com/jsp/jstl/core">
<f:view contracts="#{templateBean.contract}">
    <ui:composition template="/template.xhtml">
        <ui:define name="pageTitle">#{msg_dashboard['title']}</ui:define>
        <ui:define name="header">
            <h:outputStylesheet name="/css/dashboard.css"/>
            <f:metadata>
                <f:viewAction action="#{dashboardController.checkForRedirection()}"/>
            </f:metadata>
        </ui:define>
        <ui:define name="content">
            <p:growl id="msgs" showDetail="true"/>
            <h1>Dashboard #{dashboardController.selectedSite.name}</h1>

            <h:form>
                <!-- For Mindmap to be correctly displayed, board has to be updated twice -->
                <p:remoteCommand name="updateDashboard" update="board" oncomplete="refreshDashboard();"/>
                <p:remoteCommand name="refreshDashboard" update="board" oncomplete="setupDashboard();"/>
                <p:remoteCommand name="onPanelDrop" actionListener="#{dashboardController.onPanelDrop}"
                                 oncomplete="updateDashboard();"/>
            </h:form>

            <p:outputPanel id="pnlDashboard" style="width:100%; height: 100%;">
                <p:dashboard id="board" model="#{dashboardController.dashboard}" widgetVar="board">
                    <p:ajax event="reorder" listener="#{dashboardController.handleReorder}" update="msgs"/>
                    <c:forEach items="#{dashboardController.panels}" var="panel">
                        <p:panel id="#{panel.id}" header="#{panel.header}" toggleable="true" closable="true">
                            <p:resizable for="#{panel.id}" onResize="handleResize(event, ui)"/>
                            <p:ajax event="close" listener="#{dashboardController.handlePanelClose}"
                                    onstart="handlePanelClose()"
                                    oncomplete="setupDashboard()"/>
                            <f:facet name="actions">
                                <ui:repeat value="#{panel.actions}" var="action">
                                    <h:form>
                                        <p:commandLink action="#{action.getLink()}" onclick="#{action.onClick}"
                                                       styleClass="ui-panel-titlebar-icon ui-corner-all ui-state-default">
                                            <h:outputText styleClass="ui-icon #{action.styleClass}"/>
                                        </p:commandLink>
                                    </h:form>
                                </ui:repeat>
                            </f:facet>
                            <ui:include src="#{panel.includePath}"/>
                        </p:panel>
                    </c:forEach>
                </p:dashboard>

                <p:droppable for="board" tolerance="touch" activeStyleClass="ui-state-highlight">
                    <p:ajax listener="#{dashboardController.onPanelDrop}" update="board"/>
                </p:droppable>
            </p:outputPanel>

            <h:form id="content-form">
                <p:growl id="messages" showDetail="true"/>
                <div id="menu-bottom-btn">
                    <p:commandButton icon="fa fa-plus" oncomplete="PF('menu-bottom').show()"/>
                </div>
                <div class="fullwidth">
                    <p:sidebar widgetVar="menu-bottom" position="right" style="overflow: auto">
                        <h1>Panels</h1>
                        <div id="panel-types">
                            <c:forEach items="#{dashboardController.panelTypes}" var="panelType">
                                <p:panel styleClass="#{panelType.enabled ? '' : 'ui-state-disabled'}">
                                    <div class="dragme">
                                        <div class="dragpanel-data" style="display: none">#{panelType.name}</div>
                                        <h:commandLink action="#{dashboardController.addPanel(panelType.name)}"
                                                       style="text-decoration: none;">
                                            <div class="fa #{panelType.css}" style="padding-right: 5px;"/>
                                            <h:outputText value="#{msg_dashboard['panel.' += panelType.name]}"/>
                                        </h:commandLink>
                                    </div>
                                </p:panel>
                                <br/>
                            </c:forEach>
                        </div>
                    </p:sidebar>
                </div>
            </h:form>

            <h:outputScript name="/js/dashboard.js"/>

        </ui:define>
    </ui:composition>
</f:view>
</html>

presentation/src/main/webapp/detail.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
>
<f:view contracts="#{templateBean.contract}">
    <ui:composition template="/template.xhtml">
        <ui:define name="header">
            <f:metadata>
                <f:viewParam name="page" value="#{detailController.panelType}"/>
                <f:viewAction action="#{detailController.checkPage()}"/>
            </f:metadata>
        </ui:define>
        <ui:define name="content">
            <ui:include src="#{detailController.pagePath}"/>
        </ui:define>
    </ui:composition>
</f:view>
</html>

presentation/src/main/webapp/login.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:f="http://xmlns.jcp.org/jsf/core">
<head>
    <meta charset="UTF-8"/>
    <f:metadata>
        <f:viewAction action="#{templateController.checkUserLoggedIn}"/>
    </f:metadata>
    <title>OmniDoc</title>
    <style>
        body {
            background-color: rgba(18, 32, 52, 0.88);
            font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
            color: black;
        }

        input {
            padding: 5px;
            border-radius: 3px;
            border: 1px solid #cecece;
            background-color: #fff;
            box-shadow: 2px 2px 5px #c3c3c3;
        }

        input:focus{
            border: 1px solid #746969;
        }

        .center {
            margin: auto;
            text-align: center;
        }

        .card {
            margin: -70px 0 0 -170px;
            position: absolute;
            top: 50%;
            left: 50%;
            width: 300px;

            background-color: rgb(255, 255, 255);
            border-bottom: 3px solid #9E9E9E;
            box-shadow: 10px 10px 5px;
            padding: 20px;
            padding-bottom: 30px;
        }

        .yellow {
            color: rgb(255, 144, 18);
            display: inline;
        }

        .white {
            color: rgba(18, 32, 52, 0.88);
            display: inline;
        }

        .btn-submit {
            width: 100%;
            background-color: rgb(255, 144, 18);;
            padding: 5px;
            border: unset;
        }
    </style>
</head>
<body>
<div class="card center">
    <div id="header">
        <h1>
            <div class="yellow">Omni</div>
            <div class="white">Doc</div>
        </h1>
    </div>
    <div id="content">
        <form method="POST" action="j_security_check">
            <table class="center">
                <tbody>
                <tr>
                    <td>
                        <label for="username">#{msg['username']}</label>
                    </td>
                    <td>
                        <input id="username" name="j_username"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        <label for="password">#{msg['password']}</label>
                    </td>
                    <td>
                        <input id="password" type="password" name="j_password"/>
                    </td>
                </tr>
                <tr>
                    <td/>
                    <td>
                        <input type="submit" class="btn-submit" value="#{msg['login']}"/>
                    </td>
                </tr>
                </tbody>
            </table>
        </form>
    </div>
</div>
</body>
</html>

presentation/src/main/webapp/startpage.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:p="http://primefaces.org/ui"
      xmlns:f="http://xmlns.jcp.org/jsf/core">
<f:view contracts="#{templateBean.contract}">
    <ui:composition template="/template.xhtml">
        <ui:define name="pageTitle">#{msg_startpage['title']}</ui:define>
        <ui:define name="header">
            <h:outputStylesheet name="/css/startpage.css"/>
            <h:outputScript name="/js/startpage.js"/>
        </ui:define>
        <ui:define name="content">
            <!-- TODO: Display infobox with general information (i.e website/scripts/system resources/versions or statistics) -->
            <!-- TODO: Display box with logging information -->
            <div id="projectbar">
                <div class="ui-g">
                    <div id="projectbar__header">
                        <p>#{msg_startpage['sites']}</p>
                        <div id="btn-addsite" class="fa fa-plus-circle" onclick="PF('js-dlg-addsite').show();"/>
                    </div>

                    <h:dataTable value="#{startpageController.sites}" var="site" id="projectbar__content">
                        <h:column>
                            <h:form styleClass="site-entry">
                                <h:commandLink action="#{startpageController.onSiteEntrySelect(site)}">
                                    <div id="#{startpageController.isSelected(site) ? 'site-entry--selected' : ''}"
                                         class="fa fa-angle-double-right"/>
                                    <span>#{site.name}</span>
                                </h:commandLink>
                                <p:commandLink actionListener="#{startpageController.onSiteEntryRemoveClick(site)}">
                                    <div id="btn-removesite" class="fa fa-remove"
                                         onclick="PF('dlg-removesite').show();"/>
                                </p:commandLink>
                            </h:form>
                        </h:column>
                    </h:dataTable>
                </div>
            </div>

            <h:form>
                <p:dialog header="#{msg_startpage['createSite']}" widgetVar="js-dlg-addsite" modal="true"
                          resizable="false"
                          showEffect="fade" hideEffect="fade" focus="sitename">
                    <h:panelGrid id="pnlAddSite" style="width: 100%;">
                        <h:column>
                            <div class="ui-inputgroup">
                                <p:inputText value="#{startpageController.userName}"
                                             styleClass="ui-g-12" readonly="true"
                                             required="true" requiredMessage="#{msg_startpage['usernameRequired']}"/>
                                <span class="ui-inputgroup-addon"><i class="fa fa-user"/></span>
                            </div>
                        </h:column>

                        <p:inputText id="sitename" value="#{startpageController.siteName}"
                                     required="true" requiredMessage="#{msg_startpage['sitenameRequired']}"
                                     placeholder="#{msg_startpage['siteName']}" styleClass="ui-g-12"/>

                        <p:commandButton value="OK"
                                         actionListener="#{startpageController.addSite}"
                                         styleClass="ui-g-12 ui-g-nopad"
                                         update="projectbar__content"
                                         oncomplete="handleAddSiteRequest(xhr, status, args)"/>
                    </h:panelGrid>
                </p:dialog>
            </h:form>

            <p:dialog header="#{msg['areYouSure']}" widgetVar="dlg-removesite"
                      modal="true" resizable="false"
                      showEffect="fade" hideEffect="fade">
                <h:form>
                    <p:commandButton value="#{msg['delete']}"
                                     actionListener="#{startpageController.removeSelectedNetworkSite()}"
                                     styleClass="ui-g-12 ui-g-nopad"
                                     update="projectbar__content"
                                     onclick="PF('dlg-removesite').hide();"/>
                </h:form>
            </p:dialog>
        </ui:define>
    </ui:composition>
</f:view>
</html>